#
# ExifCu
# Morita Keisuke (morita@asobitari.nu)
# 2003,3,10
#
# ̃vORuby'sCZXƂ܂B
# http://www.ruby-lang.org/ja/LICENSE.txt
#

EXIF_HEADER = 12
JPEG_INFO_HEADER = 8
HEADER = EXIF_HEADER + JPEG_INFO_HEADER
DIR_ENTRY_SIZE = 12

module IFD_tag
  IFD_TAG = Hash.new
  IFD_TAG[0x0100] = "ImageWidth"
  IFD_TAG[0x0101] = "ImageLength"
  IFD_TAG[0x0102] = "BitsPerSample"
  IFD_TAG[0x0103] = "Compression"
  IFD_TAG[0x0106] = "PhotometricInterpretation"
  IFD_TAG[0x010e] = "ImageDescription"
  IFD_TAG[0x010f] = "Maker"
  IFD_TAG[0x0110] = "Model"
  IFD_TAG[0x0111] = "StripOffsets"
  IFD_TAG[0x0112] = "Orientation"
  IFD_TAG[0x0115] = "SamplePerPixel"
  IFD_TAG[0x0116] = "RowsPerStrip"
  IFD_TAG[0x0117] = "StripByteCounts"
  IFD_TAG[0x011a] = "XResolution"
  IFD_TAG[0x011b] = "YResolution"
  IFD_TAG[0x011c] = "PlanarConfiguration"
  IFD_TAG[0x0128] = "ResolutionUnit"
  IFD_TAG[0x0131] = "Software"
  IFD_TAG[0x0132] = "DateTime"
  IFD_TAG[0x013e] = "WhitePoint"
  IFD_TAG[0x013f] = "PrimaryChromaticities"
  IFD_TAG[0x0201] = "JpegInterchangeFormat"
  IFD_TAG[0x0202] = "JpegInterchangeFormatLength"
  IFD_TAG[0x0211] = "YCbCrCoefficients"
  IFD_TAG[0x0213] = "YCbCrPositioning"
  IFD_TAG[0x0214] = "ReferenceBlackWhite"
  IFD_TAG[0x8298] = "Copyright"
  IFD_TAG[0x8769] = "ExifIFDPointer"
  
  TYPE = [1,1,2,4,8,1,1,2,4,8,4,8]
end

class ExifInfo < Hash
  include IFD_tag 
  
  def initialize(buf,type,offset=8)
    @type = type
    0.upto(dir_entry_count(buf.slice(0,2))-1){|i|
      a = []
      a << pack(buf.slice(2+i*12,2))
      a << pack(buf.slice(4+i*12,2))
      a << lpack(buf.slice(6+i*12,4))
      if TYPE[a[1]-1] == 2      
        a << pack(buf.slice(10+i*12,4))
      else
        a << lpack(buf.slice(10+i*12,4))
      end
      
      if IFD_TAG.has_key?(a[0])
        if a[2]*TYPE[a[1]-1] <= 4
          self[IFD_TAG[a[0]]] = a[3]
        else
          if (a[1]) == 5 or (a[1]) == 8
            self[IFD_TAG[a[0]]] = "#{lpack(buf.slice(a[3]-offset,4))}/#{lpack(buf.slice(a[3]-offset+4,4))}"  
          else
            self[IFD_TAG[a[0]]] = "#{buf.slice(a[3]-offset,TYPE[a[1]-1]*a[2])}"
          end
        end
      end
    }
  end
  # fBNgGǧ
  def dir_entry_count(buf)
    pack(buf)
  end
  # g[`Ȃbuf𔽓]
  def pack(buf)
    h = {"M"=>"n","I"=>"v"}[@type]
    buf.unpack(h)[0]
  end  
  def lpack(buf)
    h = {"M"=>"N","I"=>"V"}[@type]
    buf.unpack(h)[0]
  end  
end

class ExifThumbnail < Hash
  include IFD_tag
  def initialize(buf,type,offset)
    @buf = buf
    @offset = offset
    @type = type
    0.upto(dir_entry_count(buf.slice(0,2))-1){|i|
      a = []
      a << pack(buf.slice(2+i*12,2))
      a << pack(buf.slice(4+i*12,2))
      a << lpack(buf.slice(6+i*12,4))
      if TYPE[a[1]-1] == 2      
        a << pack(buf.slice(10+i*12,4))
      else
        a << lpack(buf.slice(10+i*12,4))
      end
      
      if IFD_TAG.has_key?(a[0])
        if a[2]*TYPE[a[1]-1] <= 4
          self[IFD_TAG[a[0]]] = a[3]
        else
          if (a[1]) == 5 or (a[1]) == 8
            self[IFD_TAG[a[0]]] = "#{lpack(buf.slice(a[3]-offset,4))}/#{lpack(buf.slice(a[3]-offset+4,4))}"  
          else
            self[IFD_TAG[a[0]]] = "#{buf.slice(a[3]-offset+12,TYPE[a[1]-1]*a[2])}"
          end
        end
      end
    }   
  end
  # fBNgGǧ
  def dir_entry_count(buf)
    pack(buf)
  end
  def pack(buf)
    h = {"M"=>"n","I"=>"v"}[@type]
    buf.unpack(h)[0]
  end  
  def lpack(buf)
    h = {"M"=>"N","I"=>"V"}[@type]
    buf.unpack(h)[0]
  end  
  def compression
    if self.has_key?("Compression")
      case self["Compression"]
        when 6 then return "JPEG"
        when 1 then return "TIFF"
        else return "Undefined"
      end
    end
  end
  def image
    if compression == "JPEG"
      @buf.slice(self["JpegInterchangeFormat"]-@offset,self["JpegInterchangeFormatLength"])
    else
      nil
    end
  end
end

class Exif
  # 
  def initialize(file)
    @fname = file
    File.open(file){|f|
      f.binmode
      # Exifwb_[擾
      @buf = f.read(EXIF_HEADER)
      if self.exif?
        @buf += f.read(app1_size-EXIF_HEADER)
        
        # Jpeg摜̃wb_[擾
        # oCgь`("I" or "M")
        @data_type = @buf.slice(EXIF_HEADER,1)
         
        # Jpeg摜̏擾 ---------------------------------------
        # JpegfBNgGg
        jpg_dir_count = dir_entry_count(@buf.slice(HEADER,2))
        # TlCGg
        thumb_entry = check(@buf.slice(HEADER+2+jpg_dir_count*DIR_ENTRY_SIZE,4)).unpack("v")[0]
        # Jpeg摜IuWFNg쐬
        @info = ExifInfo.new(@buf.slice(HEADER..thumb_entry),@data_type)
        # ------------------------------------------------------------
        
        # TlC摜̏擾
        # TlCfBNgGg
        thum_dir_count = dir_entry_count(@buf.slice(thumb_entry+EXIF_HEADER,2))
        @tnd = ExifThumbnail.new(@buf.slice(thumb_entry+EXIF_HEADER..@buf.size),@data_type,thumb_entry)
      end
    }
  end  
  # Exift@CH
  def exif?
    if @buf.slice(6,6) == "Exif\000\000" then true end
  end
  # ExifTCY
  def app1_size
    @buf.slice(4,2).unpack("v")[0]
  end
  # fBNgGǧ
  def dir_entry_count(buf)
    check(buf).unpack("v")[0]
  end
  # g[`Ȃbuf𔽓]
  def check(buf)
    if @data_type == "M" then buf.reverse
    else buf end
  end
  def image
    @tnd.image
  end
  #
  attr_reader :data_type,:info,:tnd    
end
